commit 6d8bd0be14c0878ffae34dfc0abc4ba27e517ed6
Author: Athina Bekakou <athinabek@grnet.gr>
Date:   Fri Dec 13 15:50:40 2013 +0200

    new ui: update icon fonts and relative files

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/fonts/snf-font.svg b/snf-cyclades-app/synnefo/ui/new_ui/ui/fonts/snf-font.svg
index 6d12de0..a65d6bd 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/fonts/snf-font.svg
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/fonts/snf-font.svg
@@ -10,8 +10,6 @@ This is a custom SVG font generated by IcoMoon.
 <font-face units-per-em="448" ascent="384" descent="-64" />
 <missing-glyph horiz-adv-x="448" />
 <glyph class="hidden" unicode="&#xf000;" d="M0,384L 448 -64L0 -64 z" horiz-adv-x="0" />
-<glyph unicode="&#x5f;" d="M 266.356,183.744 m0,0,q 9.408,0 16.128-7.168t 6.72-16.576t-6.72-16.576t-16.128-6.72l-176.96,0l 53.312-53.312q 6.72-6.72 6.72-16.576t-6.72-16.576t-16.128-6.72q-10.304,0-17.024,6.72l-109.76,109.76l 109.76,109.76q 6.72,6.72 16.576,6.72t 16.576-6.72t 6.72-16.576t-6.72-16.576l-53.312-52.864l 176.96,0z" horiz-adv-x="289"  />
-<glyph unicode="&#x2d;" d="M 146.74,269.76 m0,0,q 6.72,6.72 16.128,6.72t 16.576-6.72l 109.76-109.76l-109.76-109.76q-6.72-6.72-16.128-6.72q-9.856,0-16.576,6.72t-6.72,16.576t 6.72,16.576l 53.76,53.312l-176.96,0q-9.856,0-16.576,6.72t-7.168,16.576t 7.168,16.576t 16.576,7.168l 176.96,0l-53.76,52.864q-6.72,6.72-6.72,16.576t 6.72,16.576z" horiz-adv-x="289"  />
 <glyph unicode="&#x28;" d="M 224.001,384L0,160L 140,160L 140-63.999L 308-64L 308,160L 448,160 z"  />
 <glyph unicode="&#x2a;" d="M 371-64L 77-64 c-11.598,0-21,9.402-21,21c0,30.127, 12.717,66.589, 34.019,97.537c 17.803,25.864, 39.674,45.334, 63.297,56.704
 		c-10.412,9.469-19.379,21.011-26.472,34.178c-11.375,21.115-17.389,45.521-17.389,70.581c0,34.828, 11.464,67.735, 32.281,92.658
@@ -112,7 +110,7 @@ This is a custom SVG font generated by IcoMoon.
 			C 78.266-28.538, 72.602-22.886, 65.69-22.886zM 108.768,362.874c-6.95,0-12.589-5.651-12.589-12.64c0-6.963, 5.638-12.589, 12.589-12.589c 6.938,0, 12.589,5.626, 12.589,12.589
 			C 121.35,357.222, 115.706,362.874, 108.768,362.874zM 108.768,320.045c-6.95,0-12.589-5.664-12.589-12.646c0-6.918, 5.638-12.576, 12.589-12.576c 6.938,0, 12.589,5.658, 12.589,12.576
 			C 121.35,314.381, 115.706,320.045, 108.768,320.045zM 108.768,19.981c-6.95,0-12.589-5.645-12.589-12.608c0-6.989, 5.638-12.589, 12.589-12.589c 6.938,0, 12.589,5.6, 12.589,12.589
-			C 121.35,14.336, 115.706,19.981, 108.768,19.981zM 96.16-35.494A12.608,12.608 1260 1 1 121.376-35.49400000000003A12.608,12.608 1260 1 1 96.16-35.49400000000003zM 151.859,362.874c-6.925,0-12.589-5.651-12.589-12.64c0-6.963, 5.664-12.589, 12.589-12.589c 6.97,0, 12.614,5.626, 12.614,12.589
+			C 121.35,14.336, 115.706,19.981, 108.768,19.981zM 96.16-35.494A12.608,12.608 1620 1 1 121.376-35.49400000000003A12.608,12.608 1620 1 1 96.16-35.49400000000003zM 151.859,362.874c-6.925,0-12.589-5.651-12.589-12.64c0-6.963, 5.664-12.589, 12.589-12.589c 6.97,0, 12.614,5.626, 12.614,12.589
 			C 164.474,357.222, 158.822,362.874, 151.859,362.874zM 151.859,320.045c-6.925,0-12.589-5.664-12.589-12.646c0-6.918, 5.664-12.576, 12.589-12.576c 6.97,0, 12.614,5.658, 12.614,12.576
 			C 164.474,314.381, 158.822,320.045, 151.859,320.045zM 151.859,19.981c-6.925,0-12.589-5.645-12.589-12.608c0-6.989, 5.664-12.589, 12.589-12.589c 6.97,0, 12.614,5.6, 12.614,12.589
 			C 164.474,14.336, 158.822,19.981, 151.859,19.981zM 151.859-22.886c-6.925,0-12.589-5.651-12.589-12.602c0-6.963, 5.664-12.614, 12.589-12.614c 6.97,0, 12.614,5.651, 12.614,12.614
@@ -123,7 +121,7 @@ This is a custom SVG font generated by IcoMoon.
 			C 207.546-28.538, 201.888-22.886, 194.976-22.886zM 238.067,362.874c-6.97,0-12.589-5.651-12.589-12.64c0-6.963, 5.619-12.589, 12.589-12.589c 6.938,0, 12.57,5.626, 12.57,12.589
 			C 250.637,357.222, 245.005,362.874, 238.067,362.874zM 238.067,320.045c-6.97,0-12.589-5.664-12.589-12.646c0-6.918, 5.619-12.576, 12.589-12.576c 6.938,0, 12.57,5.658, 12.57,12.576
 			C 250.637,314.381, 245.005,320.045, 238.067,320.045zM 238.067,19.981c-6.97,0-12.589-5.645-12.589-12.608c0-6.989, 5.619-12.589, 12.589-12.589c 6.938,0, 12.57,5.6, 12.57,12.589
-			C 250.637,14.336, 245.005,19.981, 238.067,19.981zM 225.459-35.494A12.608,12.608 1260 1 1 250.675-35.49400000000003A12.608,12.608 1260 1 1 225.459-35.49400000000003zM 281.133,362.874c-6.931,0-12.576-5.651-12.576-12.64c0-6.963, 5.651-12.589, 12.576-12.589c 6.944,0, 12.595,5.626, 12.595,12.589
+			C 250.637,14.336, 245.005,19.981, 238.067,19.981zM 225.459-35.494A12.608,12.608 1620 1 1 250.675-35.49400000000003A12.608,12.608 1620 1 1 225.459-35.49400000000003zM 281.133,362.874c-6.931,0-12.576-5.651-12.576-12.64c0-6.963, 5.651-12.589, 12.576-12.589c 6.944,0, 12.595,5.626, 12.595,12.589
 			C 293.728,357.222, 288.077,362.874, 281.133,362.874zM 281.133,320.045c-6.931,0-12.576-5.664-12.576-12.646c0-6.918, 5.651-12.576, 12.576-12.576c 6.944,0, 12.595,5.658, 12.595,12.576
 			C 293.728,314.381, 288.077,320.045, 281.133,320.045zM 281.133,19.981c-6.931,0-12.576-5.645-12.576-12.608c0-6.989, 5.651-12.589, 12.576-12.589c 6.944,0, 12.595,5.6, 12.595,12.589
 			C 293.728,14.336, 288.077,19.981, 281.133,19.981zM 281.133-22.886c-6.931,0-12.576-5.651-12.576-12.602c0-6.963, 5.651-12.614, 12.576-12.614c 6.944,0, 12.595,5.651, 12.595,12.614
@@ -612,10 +610,6 @@ This is a custom SVG font generated by IcoMoon.
 <glyph unicode="&#x43;" d="M 224,384c-123.712,0-224-100.288-224-224s 100.288-224 224-224 224,100.288 224,224-100.288,224-224,224zM 224-8c-92.784,0-168,75.216-168,168s 75.216,168 168,168c 92.784,0 168-75.216 168-168 0-92.784-75.216-168-168-168z"  />
 <glyph unicode="&#x41;" d="M 416.192,143.872q-38.080,59.136-95.424,88.256 15.232-25.984 15.232-56.448 0-46.144-32.704-79.296t-79.296-32.704-79.296,32.704-32.704,79.296q0,30.464 15.232,56.448-57.344-29.12-95.424-88.256 33.152-51.072 83.328-81.536t 108.416-30.464 108.416,30.464 83.328,81.536zM 236.096,239.744q0,4.928-3.584,8.512t-8.512,3.584q-31.36,0-53.76-22.4t-22.4-53.76q0-4.928 3.584-8.512t 8.512-3.584 8.512,3.584 3.584,8.512q0,21.504 15.232,36.736t 36.736,15.232q 4.928,0 8.512,3.584t 3.584,8.512zM 448,143.872q0-8.512-4.928-17.472-34.944-57.344-94.080-92.288t-124.992-34.496-124.992,34.944-94.080,91.84q-4.928,8.96-4.928,17.472t 4.928,17.472q 34.944,57.344 94.080,91.84t 124.992,34.944 124.992-34.944 94.080-91.84q 4.928-8.96 4.928-17.472z"  />
 <glyph unicode="&#x42;" d="M 224-64c-123.703,0-224,100.297-224,224s 100.297,224 224,224 224-100.297 224-224-100.297-224-224-224zM 224,328c-92.777,0-168-75.223-168-168s 75.223-168 168-168 168,75.223 168,168-75.223,168-168,168zM 224,48c-61.852,0-112,50.148-112,112s 50.148,112 112,112 112-50.148 112-112-50.148-112-112-112z"  />
-<glyph unicode="&#x5e;" d="M 438.317-43.846L 9.318-43.846 L 9.318,299.846 l 179.821,0 l0-53.504 l 249.184,0 L 438.323-43.846 z M 40.006-13.152l 367.61,0 l0,228.8 L 158.438,215.648 l0,53.504 L 40.006,269.152 L 40.006-13.152 z"  />
-<glyph unicode="&#x3d;" d="M 189.133,246.342L 189.133,299.846L 9.318,299.846L 9.318-43.846L 438.317-43.846L 438.317,246.342 z"  />
-<glyph unicode="&#x24;" d="M 366.259,304.109l-57.6,0 l0,64 l-153.6,0 l0-64 l-57.6,0 l-25.6,0 l0-32 l 25.6,0 l0-313.6 l 268.8,0 l0,313.6 l 25.6,0 l0,32 L 366.259,304.109 z M 334.259-9.491l-204.8,0 l0,281.6 l 204.8,0 L 334.259-9.491 z M 187.059,336.109l 89.6,0 l0-32 l-89.6,0 
-		L 187.059,336.109 zM 219.059,240.109L 251.059,240.109L 251.059,22.509L 219.059,22.509zM 155.059,240.109L 187.059,240.109L 187.059,22.509L 155.059,22.509zM 276.659,240.109L 308.659,240.109L 308.659,22.509L 276.659,22.509z"  />
 <glyph unicode="&#x3f;" d="M 361.229,318.042L 361.229,377.082 L 58.080,377.082 l0-375.2 l 59.949,0 l0-59.040 L 421.184-57.158 L 421.184,318.042 L 361.229,318.042 z M 88.781,346.394l 241.76,0 l0-313.811 L 88.781,32.582 L 88.781,346.394 z
 	 M 390.483-26.458L 148.717-26.458 l0,28.339 l 212.512,0 L 361.229,287.341 l 29.248,0 L 390.477-26.458 z"  />
 <glyph unicode="&#x25;" d="M 350.221,107.296L 251.974,11.974L 251.974,354.918L 215.622,354.918L 215.622,14.688L 128.55,106.746L 102.138,81.773L 233.242-56.832L 375.526,81.222 z"  />
@@ -634,5 +628,16 @@ This is a custom SVG font generated by IcoMoon.
 	c-88.659,0-160.806,72.576-160.806,161.779c0,52.966, 23.392,99.226, 63.725,128.742l 8.998-75.59l 39.482,4.698L 169.83,355.597L 32.198,361.741
 	l-1.779-39.718l 81.133-3.629c-48.403-37.069-77.235-94.867-77.235-158.688c0-111.123, 89.965-201.523, 200.55-201.523
 	c 111.693,0, 202.56,90.4, 202.56,201.523C 437.434,242.822, 387.763,316.397, 310.886,347.149z"  />
+<glyph unicode="&#x3d;" d="M 366.259,300.909l-57.6,0 l0,64 l-153.6,0 l0-64 l-57.6,0 l-25.6,0 l0-32 l 25.6,0 l0-313.6 l 268.8,0 l0,313.6 l 25.6,0 l0,32 L 366.259,300.909 z M 187.059,19.309l-32,0 l0,217.6 l 32,0 L 187.059,19.309 z M 251.059,19.309l-32,0 l0,217.6 l 32,0 
+	L 251.059,19.309 z M 308.659,19.309l-32,0 l0,217.6 l 32,0 L 308.659,19.309 z"  />
+<glyph unicode="&#x24;" d="M 366.259,304.109l-57.6,0 l0,64 l-153.6,0 l0-64 l-57.6,0 l-25.6,0 l0-32 l 25.6,0 l0-313.6 l 268.8,0 l0,313.6 l 25.6,0 l0,32 L 366.259,304.109 z M 334.259-9.491l-204.8,0 l0,281.6 l 204.8,0 L 334.259-9.491 z M 187.059,336.109l 89.6,0 l0-32 l-89.6,0 
+		L 187.059,336.109 zM 219.059,240.109L 251.059,240.109L 251.059,22.509L 219.059,22.509zM 155.059,240.109L 187.059,240.109L 187.059,22.509L 155.059,22.509zM 276.659,240.109L 308.659,240.109L 308.659,22.509L 276.659,22.509z"  />
+<glyph unicode="&#x5f;" d="M 176.201,319.799l-140-140c-10.935-10.934-10.935-28.663,0-39.597l 140-140c 10.935-10.934, 28.663-10.934, 39.598,0
+	c 10.936,10.934, 10.936,28.663,0,39.597L 123.597,132L 392,132 c 15.464,0, 28,12.535, 28,28c0,15.464-12.536,28-28,28L 123.597,188 l 92.201,92.201
+	C 221.266,285.668, 224,292.835, 224,300s-2.734,14.332-8.2,19.799C 204.864,330.733, 187.136,330.733, 176.201,319.799z"  />
+<glyph unicode="&#x2d;" d="M 271.799,0.201l 140,140c 10.935,10.934, 10.935,28.663,0,39.598l-140,140c-10.935,10.934-28.663,10.934-39.598,0
+	c-10.935-10.935-10.935-28.663,0-39.598L 324.402,188L 56,188 c-15.464,0-28-12.536-28-28s 12.536-28, 28-28l 268.402,0 L 232.201,39.799
+	C 226.734,34.332, 224,27.165, 224,20s 2.734-14.332, 8.2-19.799C 243.135-10.734, 260.864-10.734, 271.799,0.201z"  />
+<glyph unicode="&#x22;" d="M 359.859,281.709L 359.859,0.109L 148.666,0.109L 148.666-31.891L 391.859-31.891L 391.859,281.709 zM 91.059,345.709L 327.859,345.709L 327.859,32.109L 91.059,32.109z"  />
 <glyph unicode="&#x20;" horiz-adv-x="224" />
 </font></defs></svg>
\ No newline at end of file